searchNodes=[{"doc":"UBootEnv reads and writes U-Boot environment blocks It's like the commandline tools fw_setenv and fw_printenv except in pure Elixir. It also uses /etc/fw_env.config by default to figure out where the environment exists so that you need not store the configuration in two places.","ref":"UBootEnv.html","title":"UBootEnv","type":"module"},{"doc":"Load the U-Boot environment configuration This is returns the default U-Boot environment configuration from &quot;/etc/fw_env.config&quot; . If you do not want this, see UBootEnv.Config.from_file/1 or UBootEnv.Config.from_string/1 for creating or loading a custom configuration.","ref":"UBootEnv.html#configuration/0","title":"UBootEnv.configuration/0","type":"function"},{"doc":"Read the U-Boot environment into a map or key value pairs The configuration from &quot;/etc/fw_env.config&quot; is used to find the location of the environment block. See read/1 for specifying a custom location.","ref":"UBootEnv.html#read/0","title":"UBootEnv.read/0","type":"function"},{"doc":"Read the U-Boot environment into a map or key value pairs","ref":"UBootEnv.html#read/1","title":"UBootEnv.read/1","type":"function"},{"doc":"Write a map of key value pairs to the U-Boot environment The configuration from &quot;/etc/fw_env.config&quot; is used to find the location of the environment block. See write/2 for specifying a custom location.","ref":"UBootEnv.html#write/1","title":"UBootEnv.write/1","type":"function"},{"doc":"Write a map of key-value pairs to the U-Boot environment","ref":"UBootEnv.html#write/2","title":"UBootEnv.write/2","type":"function"},{"doc":"Utilities for reading the U-Boot's fw_env.config file.","ref":"UBootEnv.Config.html","title":"UBootEnv.Config","type":"module"},{"doc":"Return the first location","ref":"UBootEnv.Config.html#first/1","title":"UBootEnv.Config.first/1","type":"function"},{"doc":"Return whether this is a redundant environment","ref":"UBootEnv.Config.html#format/1","title":"UBootEnv.Config.format/1","type":"function"},{"doc":"Create a UBootEnv.Config from a file ( /etc/fw_env.config by default) This file should be formatted as described in from_string/1 .","ref":"UBootEnv.Config.html#from_file/1","title":"UBootEnv.Config.from_file/1","type":"function"},{"doc":"Raising version of from_file/1","ref":"UBootEnv.Config.html#from_file!/1","title":"UBootEnv.Config.from_file!/1","type":"function"},{"doc":"Create a UBootEnv.Config from the contents of an fw_env.config file Only one or two U-Boot environment locations are supported. Each location row has the following format: &lt; Device name &gt; &lt; Device offset &gt; &lt; Env . size &gt; [ Flash sector size ] [ Number of sectors ]","ref":"UBootEnv.Config.html#from_string/1","title":"UBootEnv.Config.from_string/1","type":"function"},{"doc":"Raising version of from_string/1","ref":"UBootEnv.Config.html#from_string!/1","title":"UBootEnv.Config.from_string!/1","type":"function"},{"doc":"Parse an integer Examples: iex&gt; UBootEnv.Config . parse_int ( &quot;0x12&quot; ) 18 iex&gt; UBootEnv.Config . parse_int ( &quot;1234&quot; ) 1234","ref":"UBootEnv.Config.html#parse_int/1","title":"UBootEnv.Config.parse_int/1","type":"function"},{"doc":"Return the second location This raises for nonredundant environments.","ref":"UBootEnv.Config.html#second/1","title":"UBootEnv.Config.second/1","type":"function"},{"doc":"Return the environment block size","ref":"UBootEnv.Config.html#size/1","title":"UBootEnv.Config.size/1","type":"function"},{"doc":"","ref":"UBootEnv.Config.html#t:t/0","title":"UBootEnv.Config.t/0","type":"type"},{"doc":"Functions for reading and writing raw blocks to storage This is the module that handles the low level CRC32 and redundant block details.","ref":"UBootEnv.IO.html","title":"UBootEnv.IO","type":"module"},{"doc":"Package up U-Boot environment contents The result can be written to where ever the environment block is persisted.","ref":"UBootEnv.IO.html#package/3","title":"UBootEnv.IO.package/3","type":"function"},{"doc":"Read a U-Boot environment block This function performs the actual read and in the case of redundant U-Boot environments, it returns the newer block. It does not decode.","ref":"UBootEnv.IO.html#read/1","title":"UBootEnv.IO.read/1","type":"function"},{"doc":"Unpackage a U-Boot environment block This is the opposite of package/3. It will only return successfully if the input passes the U-Boot CRC check.","ref":"UBootEnv.IO.html#unpackage/2","title":"UBootEnv.IO.unpackage/2","type":"function"},{"doc":"Write a U-Boot environment block This function performs the actual write. In the case of redundant U-Boot environments, it writes the block in the right location and marks the generation byte appropriately so that it is used on the next read. It does not encode.","ref":"UBootEnv.IO.html#write/2","title":"UBootEnv.IO.write/2","type":"function"},{"doc":"","ref":"UBootEnv.IO.html#t:generation/0","title":"UBootEnv.IO.generation/0","type":"type"},{"doc":"Environment block location","ref":"UBootEnv.Location.html","title":"UBootEnv.Location","type":"module"},{"doc":"","ref":"UBootEnv.Location.html#t:t/0","title":"UBootEnv.Location.t/0","type":"type"},{"doc":"Encode and decode a U-Boot environment data The U-Boot environment data looks like this: &quot;&lt;key&gt;=&lt;value&gt;\\0&quot; for each key-value pair &quot;\\0&quot; an empty key-value pair to terminate the list. This looks like &quot;\\0\\0&quot; when viewing the file in a hex editor.","ref":"UBootEnv.Serializer.html","title":"UBootEnv.Serializer","type":"module"},{"doc":"Decode a U-Boot environment binary data to a map of key/value pairs","ref":"UBootEnv.Serializer.html#decode/1","title":"UBootEnv.Serializer.decode/1","type":"function"},{"doc":"Encode a list of key value pairs into their binary form.","ref":"UBootEnv.Serializer.html#encode/1","title":"UBootEnv.Serializer.encode/1","type":"function"},{"doc":"This library lets you read and write U-Boot environment blocks from Elixir. U-Boot environment blocks are simple key-value stores used by the U-Boot bootloader and applications that need to communicate with it. Nerves uses U-Boot environment blocks to store settings related to the device and running firmware. Nerves uses the format even for boards (like the Raspberry Pis) that don't use the U-Boot bootloader. This library has the following features: Create, read, and write to U-Boot environment blocks in pure Elixir with OTP 21 and later Load environment block configurations from /etc/fw_env.config Redundant and non-redundant environment block support This library does not support U-Boot environment blocks stored in raw NAND Flash or big-endian blocks.","ref":"readme.html","title":"UBootEnv","type":"extras"},{"doc":"Install by adding uboot_env to your list of dependencies in mix.exs : def deps do [ { :uboot_env , &quot;~&gt; 1.0&quot; } ] end","ref":"readme.html#installation","title":"UBootEnv - Installation","type":"extras"},{"doc":"Here's an example of reading the environment: iex&gt; UBootEnv . read ( ) { :ok , %{ &quot;fdt_addr&quot; =&gt; &quot;0x83000000&quot; , &quot;stdout&quot; =&gt; &quot;serial&quot; , ... } } To change the environment, update the map returned by UBootEnv.read/0 and call UBootEnv.write/1 . If you're used to using fw_setenv , note that UBootEnv.write/1 writes the map that you give it whereas fw_setenv merges the key value pairs with the current environment. iex&gt; { :ok kv } = UBootEnv . read ( ) iex&gt; new_kv = Map . put ( kv , &quot;hello&quot; , &quot;world&quot; ) iex&gt; UBootEnv . write ( new_kv ) :ok UBootEnv.read/0 and UBootEnv.write/1 do not perform any locking of the data they write. If you have multiple processes updating the U-Boot environment block, you'll have to synchronize access to it.","ref":"readme.html#using","title":"UBootEnv - Using","type":"extras"},{"doc":"This code is Apache 2 licensed.","ref":"readme.html#license","title":"UBootEnv - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This release only changes the version number and updates documentation. No code changes were made.","ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras"},{"doc":"This release adds support for redundant U-Boot environments. It reduces the main API to UBootEnv.read/1 and UBootEnv.write/2 . If you only use those functions, your code should work without change. New features Redundant U-Boot support","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"This release breaks several APIs so please review your code. The first break is that UBootEnv.encode/2 returns iodata now. In general, the return value would end up being passed places that supported iodata, but it had previously been spec'd as returning a binary. The second break is that UBootEnv.decode/1 now does the reverse of UBootEnv.encode/2 . It previously was a convenience method, but it was public. It is not expected that many people used the previous function. Bug fixes Reduce the amount of garbage generated when encoding and decoding. A manual call to :erlang.garbage_collect/1 can free the garbage, but it stays around long enough to make any process calling this library to show up with megabytes more heap used.","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Bug fixes handle trailing whitespace in config handle 0-length strings in config handle :eof values when reading from env Updated dependencies ex_doc ~&gt; 0.20","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]